#include <stdint.h>
#include "convert.h"
#include "dist.h"
#include "sqrt.h"
#include "state.h"

uint32_t dist(int32_t *_xyz) {
    /* '/ 256' means that the maximum distance before overflow is about 1600mm */
    uint32_t h = 0;
    FOREACH_XYZ(i) {
        uint32_t d = _xyz[i] / 256;
        h += d * d;
    }
    return (uint32_t)sqrt32(h) * 256;
}

uint32_t dist_xy(int32_t *_xy) {
    uint32_t h = 0;
    FOREACH_XY(i) {
        uint32_t d = _xy[i] / 256;
        h += d * d;
    }
    return (uint32_t)sqrt32(h) * 256;
}
